/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: interrupt.h 648 2007-12-15 09:35:35Z hiro $
 */

/*
 *		ߴǽ
 */

#ifndef TOPPERS_INTERRUPT_H
#define TOPPERS_INTERRUPT_H

#ifndef OMIT_INITIALIZE_INTERRUPT

/*
 *  ߥϥɥ֥å
 */
typedef struct interrupt_handler_initialization_block {
	INHNO		inhno;			/* ߥϥɥֹ */
	ATR			inhatr;			/* ߥϥɥ° */
	FP			int_entry;		/* ߥϥɥν */
} INHINIB;

/*
 *  ׵饤֥å
 */
typedef struct interrupt_request_initialization_block {
	INTNO		intno;			/* ֹ */
	ATR			intatr;			/* ° */
	PRI			intpri;			/* ͥ */
} INTINIB;

/*
 *  ߥϥɥֹοkernel_cfg.c
 */
extern const uint_t	tnum_inhno;

/*
 *  ߥϥɥ֥åΥꥢkernel_cfg.c
 */
extern const INHINIB	inhinib_table[];

/*
 *  ׵饤οkernel_cfg.c
 */
extern const uint_t	tnum_intno;

/*
 *  ׵饤֥åΥꥢkernel_cfg.c
 */
extern const INTINIB	intinib_table[];

#endif /* OMIT_INITIALIZE_INTERRUPT */

/*
 *  ߴǽν
 */
extern void	initialize_interrupt(void);

#endif /* TOPPERS_INTERRUPT_H */
